<!DOCTYPE html>
<html lang="en">

<head>
    <title>Task 530</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <!-- Vùng header-->
    <div class="container">
        <div class="text-center mt-3">
            <h2>DANH SÁCH SẢN PHẨM</h2>
        </div>
        <div class="jumbotron container">
            <div class="row form-group">
                <label class="col-sm-2 col-form-label" for="CountrySelect">Quốc Gia</label>
                <div class="col-sm-2">
                    <select id="select-country" class="form-control">
                        <option value="optionCoutry">--Chọn quốc gia</option>
                        <option value="VN">Vietnam</option>
                        <option value="CN">China</option>
                        <option value="USA">USA</option>
                        <option value="IT">Italy</option>
                    </select>
                </div>
                <label class="col-sm-2 col-form-label" for="ProductCatogorySelect">Nhóm sản phẩm</label>
                <div class="col-sm-2">
                    <select id="select-product-category" class="form-control">
                        <option value="optionProduct">--Chọn nhóm sản phẩm</option>
                        <option value="Fashion">Fashion</option>
                        <option value="Electronics">Electronics</option>
                        <option value="Watch">Watch</option>
                    </select>
                </div>
                <div class="col-sm-2">
                    <button class="btn btn-success" id="btn-filter">Lọc sản phẩm</button>
                </div>
            </div>
        </div>
        <div class="form-group">
            <button class="btn btn-success" id="btn-add-product"><i class="fa fa-plus"></i>&nbsp; Thêm sản phẩm</button>
        </div>
    </div>
    <!--User Data Table-->
    <div class="container">
        <table class="table table-bordered table-striped table-hover" id="product-table">
            <thead>
                <tr>
                    <th>STT</th>
                    <th>Mã sản phẩm</th>
                    <th>Tên sản phẩm</th>
                    <th>Nhóm sản phẩm</th>
                    <th>Quốc gia</th>
                    <th>Ảnh đại diện</th>
                    <th>Giá bán</th>
                    <th>Giá giảm</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>
    <!--Vùng Modal-->

    <!--Create Product modal-->

    <!--Update Product modal-->
    <div>
        <div id="update-product-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Chi tiết Product</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-productCode">Mã sản phẩm</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-productCode" name="productCode"
                                        placeholder="productCode" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-productName">Tên sản phẩm</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-productName" name="productName"
                                        placeholder="productName" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="select-update-product-category" class="col-form-label col-sm-4">Nhóm sản
                                    phẩm</label>
                                <div class="col-sm-8">
                                    <select id="select-update-product-category" class="form-control">
                                        <option value="Fashion">Fashion</option>
                                        <option value="Electronics">Electronics</option>
                                        <option value="Watch">Watch</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="select-update-country" class="col-form-lable col-sm-4">Quốc gia</label>
                                <div class="col-sm-8">
                                    <select id="select-update-country" class="form-control">
                                        <option value="VN">Vietnam</option>
                                        <option value="CN">China</option>
                                        <option value="USA">USA</option>
                                        <option value="IT">Italy</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="product-image" class="col-form-lable col-sm-4">Ảnh đại diện</label>
                                <div class="col-sm-8">
                                    <img src="" alt="" id="image-product">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4" for="input-update-price">Giá bán</label>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-price" name="price" placeholder="Price"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4" for="input-update-price">Giá giảm</label>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-discount-price" name="discountrice" placeholder="Discount Price"
                                        class="form-control">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-primary" id="btn-update-user">Update User</button>
                        <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    "use strict";
    /*** REGION 1 - Global Variables */
    const gBASE_URL = "https://63b401c1ea89e3e3db539072.mockapi.io/api/v1/";
    //Biến toàn cục để lưu trữ id product đang được update or delete. Mặc định = 0;
    var gProductId = 0;

    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gPRODUCT_COLS = ["stt", "productCode", "productName", "categoryName", "countryName", "imagUrl", "price", "discountPrice"];

    //Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gPRODUCT_STT_COL = 0;
    const gPRODUCT_PRODUCT_CODE_COL = 1;
    const gPRODUCT_PRODUCT_NAME_COL = 2;
    const gPRODUCT_CATEGORY_NAME_COL = 3;
    const gPRODUCT_COUNTRY_NAME_COL = 4;
    const gPRODUCT_IMAG_URL_COL = 5;
    const gPRODUCT_PRICE__COL = 6;
    const gPRODUCT_DISCOUNT_PRICE_COL = 7;
    const gPRODUCT_ACTION_COL = 8;

    // Biến toàn cục để hiển lưu STT
    var gSTT = 1;
    // Khai báo DataTable & mapping collumns
    var gProductTable = $("#product-table").DataTable({
        columns: [
            { data: gPRODUCT_COLS[gPRODUCT_STT_COL] },
            { data: gPRODUCT_COLS[gPRODUCT_PRODUCT_CODE_COL] },
            { data: gPRODUCT_COLS[gPRODUCT_PRODUCT_NAME_COL] },
            { data: gPRODUCT_COLS[gPRODUCT_CATEGORY_NAME_COL] },
            { data: gPRODUCT_COLS[gPRODUCT_COUNTRY_NAME_COL] },
            { data: gPRODUCT_COLS[gPRODUCT_IMAG_URL_COL] },
            { data: gPRODUCT_COLS[gPRODUCT_PRICE__COL] },
            { data: gPRODUCT_COLS[gPRODUCT_DISCOUNT_PRICE_COL] }
        ],
        columnDefs: [
            {// định nghĩa lại cột STT
                targets: gPRODUCT_STT_COL,
                render: function () {
                    return gSTT++;
                }
            },
            {// định nghĩa lại cột ImageUrl
                targets: gPRODUCT_IMAG_URL_COL,
                render: function (data) {
                    return "<img src=data/>"
                }
            },
            { // định nghĩa các cột action
                targets: gPRODUCT_ACTION_COL,
                defaultContent: `
                    <img class="edit-product" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                    <img class="delete-product" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                `
            }
        ]
    });

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        // thực hiện tải trang
        onPageLoading();
    });

    // gán sự kiện Update - sửa 1 product
    $("#product-table").on("click", ".edit-product", function () {
        onBtnEditProductClick(this);
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm thực thi khi trang được load
    function onPageLoading() {
        // 1 - R: Read / Load products to DataTable
        getAllProducts();
    }

    // Hàm xử lý sự kiện khi icon edit user trên bảng được click
    function onBtnEditProductClick(paramBtnEdit) {
        //lưu thông tin productId đang được edit vào biến toàn cục
        gProductId = getProductIdFromButton(paramBtnEdit);
        console.log("Id = " + gProductId);
        //hiển thị modal trắng lên
        $("#update-product-modal").modal("show");
        // load dữ liệu vào các trường dữ liệu trong modal
        getProductById(gProductId);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm gọi api để lấy all danh sách product
    function getAllProducts() {
        $.ajax({
            url: gBASE_URL + "/products/",
            type: "GET",
            success: function (paramProducts) {
                loadDataToProductTable(paramProducts);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        });
    }

    /** load product array to DataTable
   * in: product array
   * out: product table has data
   */
    function loadDataToProductTable(paramProductArr) {
        gSTT = 1;
        gProductTable.clear();
        gProductTable.rows.add(paramProductArr);
        gProductTable.draw();
    }

    // hàm dựa vào button detail (edit or delete) xác định được id product
    function getProductIdFromButton(paramButton) {
        var vTableRow = $(paramButton).parents("tr");
        var vProductRowData = gProductTable.row(vTableRow).data();
        return vProductRowData.id;
    }

    // hàm get product by id
    function getProductById(paramUserId) {
        $.ajax({
            url: gBASE_URL + "/products/" + paramUserId,
            type: "GET",
            success: function (paramProduct) {
                showProductDataToModal(paramProduct);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        });
    }

    // hàm show user obj lên modal
    function showProductDataToModal(paramProduct) {
        $("#input-update-productCode").val(paramProduct.productCode);
        $("#input-update-productName").val(paramProduct.productName);
        $("#select-update-product-category").val(paramProduct.categoryName);
        $("#select-update-country").val(paramProduct.countryName);
        $("#image-product").val(paramProduct.imagUrl);
        $("#input-update-price").val(paramProduct.price);
        $("#input-update-discount-price").val(paramProduct.discountPrice);
    }
</script>

</html>